

#define DEVICE_VENDOR_ID                            0x1E4E
#define DEVICE_PRODUCT_ID                           0


// All the interface number set at runtime for different product
#define INTERFACE_NUMBER_CD_ROM                 0
#define INTERFACE_NUMBER_NETWORK                0
#define INTERFACE_NUMBER_VIDEO_CONTROL          0
#define INTERFACE_NUMBER_VIDEO_STREAMING        0
#define INTERFACE_NUMBER_AUDIO_CONTROL          0
#define INTERFACE_NUMBER_AUDIO_STREAMING        0
#define INTERFACE_NUMBER_CUSTOMER               0


#define ENDPOINT_NUMBER_VIDEO_ISO_IN                0x89
#define ENDPOINT_NUMBER_AUDIO_ISO_IN                0x8A


#define VIDEO_DEVICE_CLASS_VERSION                  0x0100
#define AUDIO_DEVICE_CLASS_VERSION                  0x0100

#define TERMINAL_ID_CAMERA                          0x01
#define TERMINAL_ID_VIDEO_STREAMING                 0x02

#define UNIT_ID_PROCESSING                          0x03

#define UNIT_ID_EXTENSION                           0x04

#define TERMINAL_ID_MICROPHONE                      0x01
#define TERMINAL_ID_AUDIO_STREAMING                 0x02

#define UNIT_ID_FEATURE                             0x03


// ============================================================================
//
//         FOR VIDEO DESCRIPTOR USE
//
// ============================================================================


// FPS: 30, 50, 60
#define VIDEO_FRAME_FPS                     30

// 640x480, 1280x720, 1920x1080
#define VIDEO_FRAME_WIDTH                   640
#define VIDEO_FRAME_HEIGHT                  480


// (VIDEO_FRAME_WIDTH * VIDEO_FRAME_HEIGHT * 2)
#define VIDEO_FRAME_SIZE                    0x00096000

// (VIDEO_FRAME_WIDTH * VIDEO_FRAME_HEIGHT * VIDEO_FRAME_FPS * 2 * 8)
#define VIDEO_FRAME_MIN_BIT_RATE            0x08CA0000
#define VIDEO_FRAME_MAX_BIT_RATE            0x08CA0000

// Frame Interval = (1 /FPS / 0.0000001) = (10000000 / VIDEO_FRAME_FPS) 
#define VIDEO_FRAME_INTERVAL_FPS            0x00051615           


// ============================================================================
//
// Internal Definitions
//
// ============================================================================
#define STRING_INDEX_DEVICE_SERIAL_NUMBER   3
#define STRING_INDEX_INTERFACE_NETWORK      5




#define W2B(Value)          (0xFF & (SWAP_U16(Value) >> 8)), (0xFF & SWAP_U16(Value))
#define DW2B(Value)         (0xFF & (SWAP_U32(Value) >> 24)), (0xFF & (SWAP_U32(Value) >> 16)), (0xFF & (SWAP_U32(Value) >> 8)), (0xFF & SWAP_U32(Value))




U8 code gDeviceDescSs[] =                   {0x12,0x01,0x00,0x03,0xEF,0x02,0x01,0x09,0x4E,0x1E,0x00,0x00,0x00,0x01,0x06,0x07,0x03,0x01};


U8 code gDeviceDescHs[] =                   {0x12,0x01,0x10,0x02,0xEF,0x02,0x01,0x40,0x4E,0x1E,0x00,0x00,0x00,0x01,0x06,0x07,0x03,0x01};


U8 code gDeviceDescFs[] =                   {0x12,0x01,0x00,0x02,0xEF,0x02,0x01,0x40,0x4E,0x1E,0x00,0x00,0x00,0x01,0x06,0x07,0x03,0x01};


U8 code gCustomerDeviceDescSs[] =                    {0x12,0x01,0x00,0x03,0x00,0x00,0x00,0x09,0x4E,0x1E,0x00,0x00,0x00,0x01,0x00,0x00,0x03,0x01};


U8 code gCustomerDeviceDescHs[] =                    {0x12,0x01,0x10,0x02,0x00,0x00,0x00,0x40,0x4E,0x1E,0x00,0x00,0x00,0x01,0x00,0x00,0x03,0x01};


U8 code gCustomerDeviceDescFs[] =                    {0x12,0x01,0x00,0x02,0x00,0x00,0x00,0x40,0x4E,0x1E,0x00,0x00,0x00,0x01,0x00,0x00,0x03,0x01};




U8 code gDeviceQualifierDesc[] =                    {0x0A,0x06,0x00,0x02,0xEF,0x02,0x01,0x40,0x01,0x00};


U8 code gConfigDescSs_Base[] =                          {0x09,0x02,0x00,0x00,0x00,0x01,0x00,0xA0,0x4B};


U8 code gConfigDescSs_CDROM[] =                          {0x09,0x04,0x00,0x00,0x02,0x08,0x06,0x50,0x00,0x07,0x05,0x01,0x02,0x00,0x04,0x00,0x06,0x30,0x0F,0x00,0x00,0x00,0x07,0x05,0x82,0x02,0x00,0x04,0x00,0x06,0x30,0x0F,0x00,0x00,0x00};


U8 code gConfigDescSs_HostLink[] =                              {0x09,0x04,0x00,0x00,0x03,0xFF,0x00,0x00,0x05,0x07,0x05,0x05,0x02,0x00,0x04,0x00,0x06,0x30,0x0F,0x00,0x00,0x00,0x07,0x05,0x86,0x02,0x00,0x04,0x00,0x06,0x30,0x0F,0x00,0x00,0x00,0x07,0x05,0x84,0x03,0x40,0x00,0x01,0x06,0x30,0x00,0x00,0x40,0x00};


U8 code gConfigDescSs_Grabber[] =                               {0x08,0x0B,0x00,0x02,0x0E,0x03,0x00,0x08,0x09,0x04,0x00,0x00,0x00,0x0E,0x01,0x00,0x08,0x0D,0x24,0x01,0x00,0x01,0x4D,0x00,0x00,0x0E,0x27,0x07,0x01,0x00,0x12,0x24,0x02,0x01,0x01,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0x0B,0x24,0x05,0x03,0x01,0x00,0x00,0x02,0x00,0x00,0x00,0x09,0x24,0x03,0x02,0x01,0x01,0x00,0x04,0x00,0x1A,0x24,0x06,0x04,0x5B,0x12,0x6D,0xC6,0x80,0x04,0x44,0x08,0x8C,0x26,0xB8,0x36,0x3A,0x84,0xDE,0x63,0x03,0x01,0x03,0x01,0x07,0x00,0x09,0x04,0x00,0x00,0x00,0x0E,0x02,0x00,0x08,0x0F,0x24,0x01,0x02,0x7D,0x00,0x89,0x00,0x02,0x00,0x00,0x00,0x01,0x00,0x00,0x0B,0x24,0x06,0x01,0x01,0x00,0x01,0x00,0x00,0x00,0x00,0x1E,0x24,0x07,0x01,0x00,0x80,0x02,0xE0,0x01,0x00,0x00,0xCA,0x08,0x00,0x00,0xCA,0x08,0x00,0x60,0x09,0x00,0x15,0x16,0x05,0x00,0x01,0x15,0x16,0x05,0x00,0x06,0x24,0x0D,0x01,0x01,0x04,0x1B,0x24,0x04,0x02,0x01,0x59,0x55,0x59,0x32,0x00,0x00,0x10,0x00,0x80,0x00,0x00,0xAA,0x00,0x38,0x9B,0x71,0x10,0x01,0x00,0x00,0x00,0x00,0x1E,0x24,0x05,0x01,0x00,0x80,0x02,0xE0,0x01,0x00,0x00,0xCA,0x08,0x00,0x00,0xCA,0x08,0x00,0x60,0x09,0x00,0x15,0x16,0x05,0x00,0x01,0x15,0x16,0x05,0x00,0x06,0x24,0x0D,0x01,0x01,0x04,0x09,0x04,0x00,0x01,0x01,0x0E,0x02,0x00,0x08,0x07,0x05,0x89,0x05,0x00,0x04,0x01,0x06,0x30,0x0B,0x02,0x00,0x90,0x09,0x04,0x00,0x02,0x01,0x0E,0x02,0x00,0x08,0x07,0x05,0x89,0x05,0x00,0x04,0x01,0x06,0x30,0x08,0x01,0x00,0x48,0x08,0x0B,0x00,0x02,0x01,0x02,0x00,0x09,0x09,0x04,0x00,0x00,0x00,0x01,0x01,0x00,0x09,0x09,0x24,0x01,0x00,0x01,0x26,0x00,0x01,0x00,0x0C,0x24,0x02,0x01,0x01,0x02,0x00,0x01,0x00,0x00,0x00,0x00,0x09,0x24,0x03,0x02,0x01,0x01,0x00,0x03,0x00,0x08,0x24,0x06,0x03,0x01,0x01,0x01,0x00,0x09,0x04,0x00,0x00,0x00,0x01,0x02,0x00,0x09,0x09,0x04,0x00,0x01,0x01,0x01,0x02,0x00,0x09,0x07,0x24,0x01,0x02,0x01,0x01,0x00,0x0E,0x24,0x02,0x01,0x02,0x02,0x10,0x02,0x44,0xAC,0x00,0x80,0xBB,0x00,0x07,0x05,0x8A,0x05,0xC0,0x00,0x04,0x06,0x30,0x00,0x00,0xC0,0x00,0x07,0x25,0x01,0x01,0x00,0x00,0x00};


U8 code gConfigDescSs_Customer[] =                    {0x09,0x04,0x00,0x00,0x02,0xFF,0x00,0x00,0x00,0x07,0x05,0x89,0x05,0x00,0x04,0x01,0x06,0x30,0x0B,0x02,0x00,0x90,0x07,0x05,0x8A,0x05,0xC0,0x00,0x04,0x06,0x30,0x00,0x00,0xC0,0x00};


U8 code gConfigDescHs_Base[] =                                  {0x09,0x02,0x00,0x00,0x00,0x01,0x00,0xA0,0x4B};


U8 code gConfigDescHs_CDROM[] =                                  {0x09,0x04,0x00,0x00,0x02,0x08,0x06,0x50,0x00,0x07,0x05,0x01,0x02,0x00,0x02,0x00,0x07,0x05,0x82,0x02,0x00,0x02,0x00};


U8 code gConfigDescHs_HostLink[] =                              {0x09,0x04,0x00,0x00,0x03,0xFF,0x00,0x00,0x05,0x07,0x05,0x05,0x02,0x00,0x02,0x00,0x07,0x05,0x86,0x02,0x00,0x02,0x00,0x07,0x05,0x84,0x03,0x40,0x00,0x01};


U8 code gConfigDescHs_Grabber[] =                               {0x08,0x0B,0x00,0x02,0x0E,0x03,0x00,0x08,0x09,0x04,0x00,0x00,0x00,0x0E,0x01,0x00,0x08,0x0D,0x24,0x01,0x00,0x01,0x4D,0x00,0x00,0x0E,0x27,0x07,0x01,0x00,0x12,0x24,0x02,0x01,0x01,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0x0B,0x24,0x05,0x03,0x01,0x00,0x00,0x02,0x00,0x00,0x00,0x09,0x24,0x03,0x02,0x01,0x01,0x00,0x04,0x00,0x1A,0x24,0x06,0x04,0x5B,0x12,0x6D,0xC6,0x80,0x04,0x44,0x08,0x8C,0x26,0xB8,0x36,0x3A,0x84,0xDE,0x63,0x03,0x01,0x03,0x01,0x07,0x00,0x09,0x04,0x00,0x00,0x00,0x0E,0x02,0x00,0x08,0x0E,0x24,0x01,0x01,0x3D,0x00,0x89,0x00,0x02,0x00,0x00,0x00,0x01,0x00,0x0B,0x24,0x06,0x01,0x01,0x00,0x01,0x00,0x00,0x00,0x00,0x1E,0x24,0x07,0x01,0x00,0x80,0x02,0xE0,0x01,0x00,0x00,0xCA,0x08,0x00,0x00,0xCA,0x08,0x00,0x60,0x09,0x00,0x15,0x16,0x05,0x00,0x01,0x15,0x16,0x05,0x00,0x06,0x24,0x0D,0x01,0x01,0x04,0x09,0x04,0x00,0x01,0x01,0x0E,0x02,0x00,0x08,0x07,0x05,0x89,0x05,0x00,0x14,0x01,0x08,0x0B,0x00,0x02,0x01,0x02,0x00,0x09,0x09,0x04,0x00,0x00,0x00,0x01,0x01,0x00,0x09,0x09,0x24,0x01,0x00,0x01,0x26,0x00,0x01,0x00,0x0C,0x24,0x02,0x01,0x01,0x02,0x00,0x01,0x00,0x00,0x00,0x00,0x09,0x24,0x03,0x02,0x01,0x01,0x00,0x03,0x00,0x08,0x24,0x06,0x03,0x01,0x01,0x01,0x00,0x09,0x04,0x00,0x00,0x00,0x01,0x02,0x00,0x09,0x09,0x04,0x00,0x01,0x01,0x01,0x02,0x00,0x09,0x07,0x24,0x01,0x02,0x01,0x01,0x00,0x0E,0x24,0x02,0x01,0x02,0x02,0x10,0x02,0x44,0xAC,0x00,0x80,0xBB,0x00,0x09,0x05,0x8A,0x05,0xC0,0x00,0x04,0x00,0x00,0x07,0x25,0x01,0x01,0x00,0x00,0x00};



U8 code gConfigDescHs_Customer[] =                    {0x09,0x04,0x00,0x00,0x02,0xFF,0x00,0x00,0x00,0x07,0x05,0x89,0x05,0x00,0x14,0x01,0x07,0x05,0x8A,0x05,0xC0,0x00,0x04};
U8 code gConfigDescFs_Base[] =                                  {0x09,0x02,0x00,0x00,0x00,0x01,0x00,0xA0,0x4B};


U8 code gConfigDescFs_CDROM[] =                                 {0x09,0x04,0x00,0x00,0x02,0x08,0x06,0x50,0x00,0x07,0x05,0x01,0x02,0x40,0x00,0x00,0x07,0x05,0x82,0x02,0x40,0x00,0x00};


U8 code gConfigDescFs_HostLink[] =                              {0x09,0x04,0x00,0x00,0x03,0xFF,0x00,0x00,0x05,0x07,0x05,0x05,0x02,0x40,0x00,0x00,0x07,0x05,0x86,0x02,0x40,0x00,0x00,0x07,0x05,0x84,0x03,0x40,0x00,0x01};


U8 code gConfigDescFs_Grabber[] =                               {0x08,0x0B,0x00,0x02,0x0E,0x03,0x00,0x08,0x09,0x04,0x00,0x00,0x00,0x0E,0x01,0x00,0x08,0x0D,0x24,0x01,0x00,0x01,0x4D,0x00,0x00,0x0E,0x27,0x07,0x01,0x00,0x12,0x24,0x02,0x01,0x01,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0x00,0x00,0x00,0x0B,0x24,0x05,0x03,0x01,0x00,0x00,0x02,0x00,0x00,0x00,0x09,0x24,0x03,0x02,0x01,0x01,0x00,0x04,0x00,0x1A,0x24,0x06,0x04,0x5B,0x12,0x6D,0xC6,0x80,0x04,0x44,0x08,0x8C,0x26,0xB8,0x36,0x3A,0x84,0xDE,0x63,0x03,0x01,0x03,0x01,0x07,0x00,0x09,0x04,0x00,0x00,0x00,0x0E,0x02,0x00,0x08,0x0E,0x24,0x01,0x01,0x3D,0x00,0x89,0x00,0x02,0x00,0x00,0x00,0x01,0x00,0x0B,0x24,0x06,0x01,0x01,0x00,0x01,0x00,0x00,0x00,0x00,0x1E,0x24,0x07,0x01,0x00,0x80,0x02,0xE0,0x01,0x00,0x00,0xCA,0x08,0x00,0x00,0xCA,0x08,0x00,0x60,0x09,0x00,0x15,0x16,0x05,0x00,0x02,0x15,0x16,0x05,0x00,0x06,0x24,0x0D,0x01,0x01,0x04,0x09,0x04,0x00,0x01,0x01,0x0E,0x02,0x00,0x08,0x07,0x05,0x89,0x05,0xFF,0x03,0x01,0x08,0x0B,0x00,0x02,0x01,0x02,0x00,0x09,0x09,0x04,0x00,0x00,0x00,0x01,0x01,0x00,0x09,0x09,0x24,0x01,0x00,0x01,0x26,0x00,0x01,0x00,0x0C,0x24,0x02,0x01,0x01,0x02,0x00,0x01,0x00,0x00,0x00,0x00,0x09,0x24,0x03,0x02,0x01,0x01,0x00,0x03,0x00,0x08,0x24,0x06,0x03,0x01,0x01,0x01,0x00,0x09,0x04,0x00,0x00,0x00,0x01,0x02,0x00,0x09,0x09,0x04,0x00,0x01,0x01,0x01,0x02,0x00,0x09,0x07,0x24,0x01,0x02,0x01,0x01,0x00,0x0E,0x24,0x02,0x01,0x02,0x02,0x10,0x02,0x44,0xAC,0x00,0x80,0xBB,0x00,0x09,0x05,0x8A,0x05,0xC0,0x00,0x04,0x00,0x00,0x07,0x25,0x01,0x01,0x00,0x00,0x00};


U8 code gConfigDescFs_Customer[] =                    {0x09,0x04,0x00,0x00,0x02,0xFF,0x00,0x00,0x00,0x07,0x05,0x89,0x05,0xFF,0x03,0x01,0x07,0x05,0x8A,0x05,0xC0,0x00,0x04};



U8 code gBosDesc[] =                                                    {0x05,0x0F,0x16,0x00,0x02,0x07,0x10,0x02,0x06,0x00,0x00,0x00,0x0A,0x10,0x03,0x00,0x0E,0x00,0x01,0x04,0x04,0x00};




// ============================================================================
//
//         FOR VIDEO DESCRIPTOR USE
//
// ============================================================================

//
//      MJPG Huffman Table 
//

U8 code gMjpgHuffmanTable[] =           {0x04,0xA0,0x00,0x02,0x00,0x00,0x03,0x40,0x00,0x03,0x60,0x00,0x03,0x80,0x00,0x03,0xA0,0x00,0x03,0xC0,0x00,0x04,0xE0,0x00,0x05,0xF0,0x00,0x06,0xF8,0x00,0x07,0xFC,0x00,0x08,0xFE,0x00,0x09,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0B,0xFF,0x20,0x02,0x00,0x00,0x04,0xC0,0x00,0x05,0xE0,0x00,0x06,0xE8,0x00,0x06,0xEC,0x00,0x07,0xF4,0x00,0x07,0xF6,0x00,0x08,0xFA,0x00,0x09,0xFC,0x00,0x09,0xFC,0x80,0x09,0xFD,0x00,0x0A,0xFE,0x40,0x0A,0xFE,0x80,0x0B,0xFF,0x00,0x00,0xFF,0xEB,0x00,0xFF,0xF5,0x02,0x40,0x00,0x05,0xD8,0x00,0x08,0xF9,0x00,0x09,0xFB,0x80,0x0A,0xFE,0x00,0x0B,0xFE,0xE0,0x0C,0xFF,0x60,0x0C,0xFF,0x70,0x0F,0xFF,0x80,0x00,0xFF,0xBE,0x00,0xFF,0xC7,0x00,0xFF,0xD0,0x00,0xFF,0xD9,0x00,0xFF,0xE2,0x00,0xFF,0xEC,0x00,0xFF,0xF6,0x03,0x80,0x00,0x07,0xF2,0x00,0x0A,0xFD,0xC0,0x0C,0xFF,0x50,0x00,0xFF,0x96,0x00,0xFF,0x9E,0x00,0xFF,0xA6,0x00,0xFF,0xAE,0x00,0xFF,0xB6,0x00,0xFF,0xBF,0x00,0xFF,0xC8,0x00,0xFF,0xD1,0x00,0xFF,0xDA,0x00,0xFF,0xE3,0x00,0xFF,0xED,0x00,0xFF,0xF7,0x04,0xB0,0x00,0x09,0xFB,0x00,0x0C,0xFF,0x40,0x00,0xFF,0x8F,0x00,0xFF,0x97,0x00,0xFF,0x9F,0x00,0xFF,0xA7,0x00,0xFF,0xAF,0x00,0xFF,0xB7,0x00,0xFF,0xC0,0x00,0xFF,0xC9,0x00,0xFF,0xD2,0x00,0xFF,0xDB,0x00,0xFF,0xE4,0x00,0xFF,0xEE,0x00,0xFF,0xF8,0x05,0xD0,0x00,0x0B,0xFE,0xC0,0x00,0xFF,0x89,0x00,0xFF,0x90,0x00,0xFF,0x98,0x00,0xFF,0xA0,0x00,0xFF,0xA8,0x00,0xFF,0xB0,0x00,0xFF,0xB8,0x00,0xFF,0xC1,0x00,0xFF,0xCA,0x00,0xFF,0xD3,0x00,0xFF,0xDC,0x00,0xFF,0xE5,0x00,0xFF,0xEF,0x00,0xFF,0xF9,0x07,0xF0,0x00,0x00,0xFF,0x84,0x00,0xFF,0x8A,0x00,0xFF,0x91,0x00,0xFF,0x99,0x00,0xFF,0xA1,0x00,0xFF,0xA9,0x00,0xFF,0xB1,0x00,0xFF,0xB9,0x00,0xFF,0xC2,0x00,0xFF,0xCB,0x00,0xFF,0xD4,0x00,0xFF,0xDD,0x00,0xFF,0xE6,0x00,0xFF,0xF0,0x00,0xFF,0xFA,0x08,0xF8,0x00,0x00,0xFF,0x85,0x00,0xFF,0x8B,0x00,0xFF,0x92,0x00,0xFF,0x9A,0x00,0xFF,0xA2,0x00,0xFF,0xAA,0x00,0xFF,0xB2,0x00,0xFF,0xBA,0x00,0xFF,0xC3,0x00,0xFF,0xCC,0x00,0xFF,0xD5,0x00,0xFF,0xDE,0x00,0xFF,0xE7,0x00,0xFF,0xF1,0x00,0xFF,0xFB,0x0A,0xFD,0x80,0x00,0xFF,0x86,0x00,0xFF,0x8C,0x00,0xFF,0x93,0x00,0xFF,0x9B,0x00,0xFF,0xA3,0x00,0xFF,0xAB,0x00,0xFF,0xB3,0x00,0xFF,0xBB,0x00,0xFF,0xC4,0x00,0xFF,0xCD,0x00,0xFF,0xD6,0x00,0xFF,0xDF,0x00,0xFF,0xE8,0x00,0xFF,0xF2,0x00,0xFF,0xFC,0x00,0xFF,0x82,0x00,0xFF,0x87,0x00,0xFF,0x8D,0x00,0xFF,0x94,0x00,0xFF,0x9C,0x00,0xFF,0xA4,0x00,0xFF,0xAC,0x00,0xFF,0xB4,0x00,0xFF,0xBC,0x00,0xFF,0xC5,0x00,0xFF,0xCE,0x00,0xFF,0xD7,0x00,0xFF,0xE0,0x00,0xFF,0xE9,0x00,0xFF,0xF3,0x00,0xFF,0xFD,0x00,0xFF,0x83,0x00,0xFF,0x88,0x00,0xFF,0x8E,0x00,0xFF,0x95,0x00,0xFF,0x9D,0x00,0xFF,0xA5,0x00,0xFF,0xAD,0x00,0xFF,0xB5,0x00,0xFF,0xBD,0x00,0xFF,0xC6,0x00,0xFF,0xCF,0x00,0xFF,0xD8,0x00,0xFF,0xE1,0x00,0xFF,0xEA,0x00,0xFF,0xF4,0x00,0xFF,0xFE,0x02,0x00,0x00,0x02,0x00,0x00,0x02,0x40,0x00,0x02,0x80,0x00,0x03,0xC0,0x00,0x04,0xE0,0x00,0x05,0xF0,0x00,0x06,0xF8,0x00,0x07,0xFC,0x00,0x08,0xFE,0x00,0x09,0xFF,0x00,0x0A,0xFF,0x80,0x0B,0xFF,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x0A,0xFE,0x80,0x02,0x40,0x00,0x04,0xB0,0x00,0x05,0xD0,0x00,0x05,0xD8,0x00,0x06,0xE8,0x00,0x06,0xEC,0x00,0x07,0xF2,0x00,0x07,0xF4,0x00,0x08,0xF9,0x00,0x09,0xFB,0x80,0x09,0xFC,0x00,0x09,0xFC,0x80,0x09,0xFD,0x00,0x0B,0xFF,0x20,0x0E,0xFF,0x80,0x0F,0xFF,0x86,0x03,0x80,0x00,0x06,0xE4,0x00,0x08,0xF7,0x00,0x08,0xF8,0x00,0x09,0xFB,0x00,0x0A,0xFE,0x40,0x0B,0xFE,0xE0,0x0B,0xFF,0x00,0x00,0xFF,0xB7,0x00,0xFF,0xC0,0x00,0xFF,0xC9,0x00,0xFF,0xD2,0x00,0xFF,0xDB,0x00,0xFF,0xE4,0x00,0xFF,0xED,0x00,0xFF,0xF6,0x04,0xA0,0x00,0x08,0xF6,0x00,0x0A,0xFD,0xC0,0x0A,0xFE,0x00,0x00,0xFF,0x97,0x00,0xFF,0x9F,0x00,0xFF,0xA7,0x00,0xFF,0xAF,0x00,0xFF,0xB8,0x00,0xFF,0xC1,0x00,0xFF,0xCA,0x00,0xFF,0xD3,0x00,0xFF,0xDC,0x00,0xFF,0xE5,0x00,0xFF,0xEE,0x00,0xFF,0xF7,0x05,0xC0,0x00,0x09,0xFA,0x80,0x0C,0xFF,0x60,0x0C,0xFF,0x70,0x00,0xFF,0x98,0x00,0xFF,0xA0,0x00,0xFF,0xA8,0x00,0xFF,0xB0,0x00,0xFF,0xB9,0x00,0xFF,0xC2,0x00,0xFF,0xCB,0x00,0xFF,0xD4,0x00,0xFF,0xDD,0x00,0xFF,0xE6,0x00,0xFF,0xEF,0x00,0xFF,0xF8,0x05,0xC8,0x00,0x0B,0xFE,0xC0,0x0F,0xFF,0x84,0x00,0xFF,0x91,0x00,0xFF,0x99,0x00,0xFF,0xA1,0x00,0xFF,0xA9,0x00,0xFF,0xB1,0x00,0xFF,0xBA,0x00,0xFF,0xC3,0x00,0xFF,0xCC,0x00,0xFF,0xD5,0x00,0xFF,0xDE,0x00,0xFF,0xE7,0x00,0xFF,0xF0,0x00,0xFF,0xF9,0x06,0xE0,0x00,0x0C,0xFF,0x50,0x00,0xFF,0x8C,0x00,0xFF,0x92,0x00,0xFF,0x9A,0x00,0xFF,0xA2,0x00,0xFF,0xAA,0x00,0xFF,0xB2,0x00,0xFF,0xBB,0x00,0xFF,0xC4,0x00,0xFF,0xCD,0x00,0xFF,0xD6,0x00,0xFF,0xDF,0x00,0xFF,0xE8,0x00,0xFF,0xF1,0x00,0xFF,0xFA,0x07,0xF0,0x00,0x00,0xFF,0x88,0x00,0xFF,0x8D,0x00,0xFF,0x93,0x00,0xFF,0x9B,0x00,0xFF,0xA3,0x00,0xFF,0xAB,0x00,0xFF,0xB3,0x00,0xFF,0xBC,0x00,0xFF,0xC5,0x00,0xFF,0xCE,0x00,0xFF,0xD7,0x00,0xFF,0xE0,0x00,0xFF,0xE9,0x00,0xFF,0xF2,0x00,0xFF,0xFB,0x09,0xFA,0x00,0x00,0xFF,0x89,0x00,0xFF,0x8E,0x00,0xFF,0x94,0x00,0xFF,0x9C,0x00,0xFF,0xA4,0x00,0xFF,0xAC,0x00,0xFF,0xB4,0x00,0xFF,0xBD,0x00,0xFF,0xC6,0x00,0xFF,0xCF,0x00,0xFF,0xD8,0x00,0xFF,0xE1,0x00,0xFF,0xEA,0x00,0xFF,0xF3,0x00,0xFF,0xFC,0x0A,0xFD,0x80,0x00,0xFF,0x8A,0x00,0xFF,0x8F,0x00,0xFF,0x95,0x00,0xFF,0x9D,0x00,0xFF,0xA5,0x00,0xFF,0xAD,0x00,0xFF,0xB5,0x00,0xFF,0xBE,0x00,0xFF,0xC7,0x00,0xFF,0xD0,0x00,0xFF,0xD9,0x00,0xFF,0xE2,0x00,0xFF,0xEB,0x00,0xFF,0xF4,0x00,0xFF,0xFD,0x0C,0xFF,0x40,0x00,0xFF,0x8B,0x00,0xFF,0x90,0x00,0xFF,0x96,0x00,0xFF,0x9E,0x00,0xFF,0xA6,0x00,0xFF,0xAE,0x00,0xFF,0xB6,0x00,0xFF,0xBF,0x00,0xFF,0xC8,0x00,0xFF,0xD1,0x00,0xFF,0xDA,0x00,0xFF,0xE3,0x00,0xFF,0xEC,0x00,0xFF,0xF5,0x00,0xFF,0xFE};

U8 code gZigZagScan[] =     {0x00,0x01,0x05,0x06,0x0E,0x0F,0x1B,0x1C,0x02,0x04,0x07,0x0D,0x10,0x1A,0x1D,0x2A,0x03,0x08,0x0C,0x11,0x19,0x1E,0x29,0x2B,0x09,0x0B,0x12,0x18,0x1F,0x28,0x2C,0x35,0x0A,0x13,0x17,0x20,0x27,0x2D,0x34,0x36,0x14,0x16,0x21,0x26,0x2E,0x33,0x37,0x3C,0x15,0x22,0x25,0x2F,0x32,0x38,0x3B,0x3D,0x23,0x24,0x30,0x31,0x39,0x3A,0x3E,0x3F};

U8 code gDQT_Y[] =              {0x06,0x04,0x05,0x06,0x05,0x04,0x06,0x06,0x05,0x06,0x07,0x07,0x06,0x08,0x0A,0x10,0x0A,0x0A,0x09,0x09,0x0A,0x14,0x0E,0x0F,0x0C,0x10,0x17,0x14,0x18,0x18,0x17,0x14,0x16,0x16,0x1A,0x1D,0x25,0x1F,0x1A,0x1B,0x23,0x1C,0x16,0x16,0x20,0x2C,0x20,0x23,0x26,0x27,0x29,0x2A,0x29,0x19,0x1F,0x2D,0x30,0x2D,0x28,0x30,0x25,0x28,0x29,0x28};

U8 code gDQT_CbCr[] =           {0x07,0x07,0x07,0x0A,0x08,0x0A,0x13,0x0A,0x0A,0x13,0x28,0x1A,0x16,0x1A,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28};


//
//      MJPG Headrer 
//

U8 code gMjpgHeader[] =                     {0xFF,0xD8,0xFF,0xDB,0x00,0x43,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xDB,0x00,0x43,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xC0,0x00,0x11,0x08,0x00,0xF0,0x01,0x40,0x03,0x01,0x21,0x00,0x02,0x11,0x01,0x03,0x11,0x01,0xFF,0xC4,0x00,0x1F,0x00,0x00,0x01,0x05,0x01,0x01,0x01,0x01,0x01,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0xFF,0xC4,0x00,0xB5,0x10,0x00,0x02,0x01,0x03,0x03,0x02,0x04,0x03,0x05,0x05,0x04,0x04,0x00,0x00,0x01,0x7D,0x01,0x02,0x03,0x00,0x04,0x11,0x05,0x12,0x21,0x31,0x41,0x06,0x13,0x51,0x61,0x07,0x22,0x71,0x14,0x32,0x81,0x91,0xA1,0x08,0x23,0x42,0xB1,0xC1,0x15,0x52,0xD1,0xF0,0x24,0x33,0x62,0x72,0x82,0x09,0x0A,0x16,0x17,0x18,0x19,0x1A,0x25,0x26,0x27,0x28,0x29,0x2A,0x34,0x35,0x36,0x37,0x38,0x39,0x3A,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4A,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5A,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6A,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7A,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9A,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFF,0xC4,0x00,0x1F,0x01,0x00,0x03,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0xFF,0xC4,0x00,0xB5,0x11,0x00,0x02,0x01,0x02,0x04,0x04,0x03,0x04,0x07,0x05,0x04,0x04,0x00,0x01,0x02,0x77,0x00,0x01,0x02,0x03,0x11,0x04,0x05,0x21,0x31,0x06,0x12,0x41,0x51,0x07,0x61,0x71,0x13,0x22,0x32,0x81,0x08,0x14,0x42,0x91,0xA1,0xB1,0xC1,0x09,0x23,0x33,0x52,0xF0,0x15,0x62,0x72,0xD1,0x0A,0x16,0x24,0x34,0xE1,0x25,0xF1,0x17,0x18,0x19,0x1A,0x26,0x27,0x28,0x29,0x2A,0x35,0x36,0x37,0x38,0x39,0x3A,0x43,0x44,0x45,0x46,0x47,0x48,0x49,0x4A,0x53,0x54,0x55,0x56,0x57,0x58,0x59,0x5A,0x63,0x64,0x65,0x66,0x67,0x68,0x69,0x6A,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0x7A,0x82,0x83,0x84,0x85,0x86,0x87,0x88,0x89,0x8A,0x92,0x93,0x94,0x95,0x96,0x97,0x98,0x99,0x9A,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8,0xA9,0xAA,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0xB8,0xB9,0xBA,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,0xC8,0xC9,0xCA,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,0xE8,0xE9,0xEA,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,0xF8,0xF9,0xFA,0xFF,0xDA,0x00,0x0C,0x03,0x01,0x00,0x02,0x11,0x03,0x11,0x00,0x3F,0x00};


//
//      Codec Vtime Table 
//

U8 code gCodec_Vtime_table[] =                      {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,0x80,0x02,0xE0,0x01,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x02,0xD0,0x02,0xE0,0x01,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x03,0xD0,0x02,0xE0,0x01,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x04,0x00,0x05,0xD0,0x02,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x05,0x80,0x07,0x1C,0x02,0x3C,0x00,0x24,0x28,0x3F,0x32,0x03,0x06,0xA0,0x05,0xF0,0x00,0x3C,0x00,0x24,0x28,0x3F,0x32,0x03,0x07,0xA0,0x05,0xF0,0x00,0x3C,0x00,0x24,0x28,0x3F,0x32,0x03,0x08,0xA0,0x05,0xF0,0x00,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x09,0xA0,0x05,0xF0,0x00,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x0A,0x40,0x0B,0xF0,0x00,0x3C,0x00,0x24,0x28,0x3F,0x32,0x03,0x0B,0x40,0x0B,0xF0,0x00,0x3C,0x00,0x24,0x28,0x3F,0x32,0x03,0x0C,0x40,0x0B,0xF0,0x00,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x0D,0x40,0x0B,0xF0,0x00,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x0E,0xA0,0x05,0xE0,0x01,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x0F,0xA0,0x05,0xE0,0x01,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x10,0x80,0x07,0x38,0x04,0x3C,0x01,0x16,0x14,0x3F,0x28,0x03,0x11,0xD0,0x02,0x40,0x02,0x32,0x01,0x24,0x28,0x3F,0x32,0x03,0x12,0xD0,0x02,0x40,0x02,0x32,0x01,0x24,0x28,0x3F,0x32,0x03,0x13,0x00,0x05,0xD0,0x02,0x32,0x01,0x24,0x28,0x3F,0x32,0x03,0x14,0x80,0x07,0x1C,0x02,0x32,0x00,0x20,0x14,0x3F,0x28,0x03,0x15,0xA0,0x05,0x20,0x01,0x32,0x00,0x24,0x28,0x3F,0x32,0x03,0x16,0xA0,0x05,0x20,0x01,0x32,0x00,0x24,0x28,0x3F,0x32,0x03,0x17,0xA0,0x05,0x20,0x01,0x32,0x01,0x24,0x28,0x3F,0x32,0x03,0x18,0xA0,0x05,0x20,0x01,0x32,0x01,0x24,0x28,0x3F,0x32,0x03,0x19,0x40,0x0B,0x20,0x01,0x32,0x00,0x24,0x28,0x3F,0x32,0x03,0x1A,0x40,0x0B,0x20,0x01,0x32,0x00,0x24,0x28,0x3F,0x32,0x03,0x1B,0x40,0x0B,0x20,0x01,0x32,0x01,0x24,0x28,0x3F,0x32,0x03,0x1C,0x40,0x0B,0x20,0x01,0x32,0x01,0x24,0x28,0x3F,0x32,0x03,0x1D,0xA0,0x05,0x40,0x02,0x32,0x01,0x24,0x28,0x3F,0x32,0x03,0x1E,0xA0,0x05,0x40,0x02,0x32,0x01,0x24,0x28,0x3F,0x32,0x03,0x1F,0x80,0x07,0x38,0x04,0x32,0x01,0x20,0x14,0x3F,0x28,0x03,0x20,0x80,0x07,0x38,0x04,0x18,0x01,0x20,0x14,0x3F,0x28,0x03,0x21,0x80,0x07,0x38,0x04,0x19,0x01,0x20,0x14,0x3F,0x28,0x03,0x22,0x80,0x07,0x38,0x04,0x1E,0x01,0x20,0x14,0x3F,0x28,0x03,0x23,0x40,0x0B,0xE0,0x01,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x24,0x40,0x0B,0xE0,0x01,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x25,0x40,0x0B,0x40,0x02,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x26,0x40,0x0B,0x40,0x02,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x27,0x80,0x07,0x1C,0x02,0x32,0x00,0x24,0x28,0x3F,0x32,0x03,0x28,0x80,0x07,0x1C,0x02,0x64,0x00,0x20,0x14,0x3F,0x28,0x03,0x29,0x00,0x05,0xD0,0x02,0x64,0x01,0x24,0x28,0x3F,0x32,0x03,0x2A,0xD0,0x02,0x40,0x02,0x64,0x01,0x24,0x28,0x3F,0x32,0x03,0x2B,0xD0,0x02,0x40,0x02,0x64,0x01,0x24,0x28,0x3F,0x32,0x03,0x2C,0xA0,0x05,0x20,0x01,0x64,0x00,0x24,0x28,0x3F,0x32,0x03,0x2D,0xA0,0x05,0x20,0x01,0x64,0x00,0x24,0x28,0x3F,0x32,0x03,0x2E,0x80,0x07,0x1C,0x02,0x78,0x00,0x20,0x14,0x3F,0x28,0x03,0x2F,0x00,0x05,0xD0,0x02,0x78,0x01,0x24,0x28,0x3F,0x32,0x03,0x30,0xD0,0x02,0xE0,0x01,0x78,0x01,0x24,0x28,0x3F,0x32,0x03,0x31,0xD0,0x02,0xE0,0x01,0x78,0x01,0x24,0x28,0x3F,0x32,0x03,0x32,0xA0,0x05,0xF0,0x00,0x78,0x00,0x24,0x28,0x3F,0x32,0x03,0x33,0xA0,0x05,0xF0,0x00,0x78,0x00,0x24,0x28,0x3F,0x32,0x03,0x34,0xD0,0x02,0x40,0x02,0xC8,0x01,0x24,0x28,0x3F,0x32,0x03,0x35,0xD0,0x02,0x40,0x02,0xC8,0x01,0x24,0x28,0x3F,0x32,0x03,0x36,0xA0,0x05,0x20,0x01,0xC8,0x00,0x24,0x28,0x3F,0x32,0x03,0x37,0xA0,0x05,0x20,0x01,0xC8,0x00,0x24,0x28,0x3F,0x32,0x03,0x38,0xD0,0x02,0xE0,0x01,0xF0,0x01,0x24,0x28,0x3F,0x32,0x03,0x39,0xD0,0x02,0xE0,0x01,0xF0,0x01,0x24,0x28,0x3F,0x32,0x03,0x3A,0xA0,0x05,0xF0,0x00,0xF0,0x00,0x24,0x28,0x3F,0x32,0x03,0x3B,0xA0,0x05,0xF0,0x00,0xF0,0x00,0x24,0x28,0x3F,0x32,0x03,0x80,0x80,0x02,0x5E,0x01,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x84,0x80,0x02,0x90,0x01,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x88,0xD0,0x02,0x90,0x01,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x8C,0x80,0x02,0xE0,0x01,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x90,0x20,0x03,0x58,0x02,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x94,0x50,0x03,0xE0,0x01,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x98,0x00,0x04,0x00,0x03,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0x9C,0x80,0x04,0x60,0x03,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0xA0,0x00,0x05,0x00,0x03,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0xA4,0x00,0x05,0xC0,0x03,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0xA8,0x00,0x05,0x00,0x04,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0xAC,0x50,0x05,0x00,0x03,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0xB0,0x78,0x05,0x1A,0x04,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0xB4,0xA0,0x05,0x84,0x03,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0xB8,0x40,0x06,0xB0,0x04,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0xBC,0x90,0x06,0x1A,0x04,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0xC0,0x00,0x07,0x40,0x05,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0xC4,0x40,0x07,0x70,0x05,0x3C,0x01,0x24,0x28,0x3F,0x32,0x03,0xC8,0x80,0x07,0xB0,0x04,0x3C,0x01,0x20,0x14,0x3F,0x28,0x03,0xCC,0x80,0x07,0xA0,0x05,0x3C,0x01,0x20,0x14,0x3F,0x28,0x03,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03};



